Package org.apache.sysds.parser

# Class IndexedIdentifier

java.lang.Object
org.apache.sysds.parser.Expression
org.apache.sysds.parser.Identifier
org.apache.sysds.parser.DataIdentifier
org.apache.sysds.parser.IndexedIdentifier

All Implemented Interfaces:
  `ParseInfo`

public class IndexedIdentifier extends DataIdentifier

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.sysds.parser.Expression

`Expression.BinaryOp, Expression.BooleanOp, Expression.DataOp, Expression.FunctCallOp, Expression.RelationalOp`

## Constructor Summary

Constructors
Constructor
Description
`IndexedIdentifier(String name, boolean passedRows, boolean passedCols)`

## Method Summary

Modifier and Type
Method
Description
`org.apache.sysds.parser.IndexPair`
`calculateIndexedDimensions(HashMap<String,DataIdentifier> ids, HashMap<String,ConstIdentifier> currConstVars, boolean conditional)`
`Expression`
`getColLowerBound()`
`boolean`
`getColLowerEqualsUpper()`
`Expression`
`getColUpperBound()`
`long`
`getOrigDim1()`
`long`
`getOrigDim2()`
`Expression`
`getRowLowerBound()`
`boolean`
`getRowLowerEqualsUpper()`
`Expression`
`getRowUpperBound()`
`boolean`
`multipleReturns()`
Method to specify if an expression returns multiple outputs.
`Expression`
`rewriteExpression(String prefix)`
`void`
`setColLowerBound(Expression passed)`
`void`
`setColLowerEqualsUpper(boolean passed)`
`void`
`setColUpperBound(Expression passed)`
`void`
`setIndices(ArrayList<ArrayList<Expression>> passed)`
`void`
`setOriginalDimensions(long passedDim1, long passedDim2)`
`void`
`setProperties(Identifier i)`
`void`
`setRowLowerBound(Expression passed)`
`void`
`setRowLowerEqualsUpper(boolean passed)`
`void`
`setRowUpperBound(Expression passed)`
`String`
`toString()`
`VariableSet`
`variablesRead()`

### Methods inherited from class org.apache.sysds.parser.DataIdentifier

`equals, getName, hashCode, setName, variablesUpdated`

### Methods inherited from class org.apache.sysds.parser.Identifier

`computeDataType, dimsKnown, getBlocksize, getDataType, getDim1, getDim2, getFileFormat, getNnz, getValueType, isScalarBoolean, setBlocksize, setBooleanProperties, setDataType, setDimensions, setDimensionValueProperties, setFileFormat, setIntProperties, setNnz, setValueType, validateExpression`

### Methods inherited from class org.apache.sysds.parser.Expression

`computeDataType, computeDataType, computeValueType, computeValueType, computeValueType, convertFormatType, getBeginColumn, getBeginLine, getBinaryMatrixCharacteristics, getBinaryOp, getBooleanOp, getEndColumn, getEndLine, getFilename, getOutput, getOutputs, getParseExceptionList, getRelationalOp, getTempName, getText, printErrorLocation, printInfoLocation, printWarningLocation, raiseValidateError, raiseValidateError, raiseValidateError, setBeginColumn, setBeginLine, setCtxValues, setCtxValuesAndFilename, setEndColumn, setEndLine, setFilename, setOutput, setParseExceptionList, setParseInfo, setText, validateExpression`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### IndexedIdentifier

public IndexedIdentifier(String name, boolean passedRows, boolean passedCols)

## Method Details

### getRowLowerEqualsUpper

public boolean getRowLowerEqualsUpper()

### getColLowerEqualsUpper

public boolean getColLowerEqualsUpper()

### setRowLowerEqualsUpper

public void setRowLowerEqualsUpper(boolean passed)

### setColLowerEqualsUpper

public void setColLowerEqualsUpper(boolean passed)

### calculateIndexedDimensions

public org.apache.sysds.parser.IndexPair calculateIndexedDimensions(HashMap<String,DataIdentifier> ids, HashMap<String,ConstIdentifier> currConstVars, boolean conditional)

### setOriginalDimensions

public void setOriginalDimensions(long passedDim1, long passedDim2)

### getOrigDim1

public long getOrigDim1()

### getOrigDim2

public long getOrigDim2()

### rewriteExpression

public Expression rewriteExpression(String prefix)

Overrides:
  `rewriteExpression` in class `DataIdentifier`

### setIndices

public void setIndices(ArrayList<ArrayList<Expression>> passed)

### getRowLowerBound

public Expression getRowLowerBound()

### getRowUpperBound

public Expression getRowUpperBound()

### getColLowerBound

public Expression getColLowerBound()

### getColUpperBound

public Expression getColUpperBound()

### setRowLowerBound

public void setRowLowerBound(Expression passed)

### setRowUpperBound

public void setRowUpperBound(Expression passed)

### setColLowerBound

public void setColLowerBound(Expression passed)

### setColUpperBound

public void setColUpperBound(Expression passed)

### toString

public String toString()

Overrides:
  `toString` in class `DataIdentifier`

### variablesRead

public VariableSet variablesRead()

Overrides:
  `variablesRead` in class `DataIdentifier`

### setProperties

public void setProperties(Identifier i)

Overrides:
  `setProperties` in class `Identifier`

### multipleReturns

public boolean multipleReturns()
Description copied from class: `DataIdentifier`
Method to specify if an expression returns multiple outputs. This method must be overridden by all child classes.

Overrides:
  `multipleReturns` in class `DataIdentifier`
Returns:
  true if expression returns multiple outputs